# Generated by rust2rpm 26
%bcond_without check

# prevent library files from being installed
%global cargo_install_lib 0

# Disable debug package generation
%global debug_package %{nil}

Name:           steamos-manager
Version:        25.3.1
Release:        %autorelease
Summary:        SteamOS Manager daemon for running various tasks as root

License:        MIT

URL:            https://gitlab.com/evlaV/steamos-manager
Source:         %{url}/-/archive/v%{version}/steamos-manager-v%{version}.tar.gz
Source1:        steamos-manager-%{version}-vendor.tar.xz
Patch1:         0001-fedora-changes.patch
Patch2:         bazzite.patch

BuildRequires:  cargo-rpm-macros >= 26
BuildRequires:  cargo
BuildRequires:  rust-packaging
BuildRequires:  systemd-rpm-macros
BuildRequires:  clang-devel
BuildRequires:  cmake
BuildRequires:  rust
BuildRequires:  rust-std-static
BuildRequires:  pkgconfig(expat)
BuildRequires:  pkgconfig(gbm)
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(libdrm)
BuildRequires:  pkgconfig(libinput)
BuildRequires:  pkgconfig(libseat)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(xkbcommon)
BuildRequires:  pkgconfig(libzstd)
BuildRequires:  desktop-file-utils


%description

%prep
%autosetup -n %{name}-v%{version} -p1 -a1
%cargo_prep -v vendor

%build
%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies
%{cargo_vendor_manifest}

%install
%cargo_install

# Create the necessary directories
install -d -m0755 %{buildroot}%{_datadir}/dbus-1/services/
install -d -m0755 %{buildroot}%{_datadir}/dbus-1/system-services/
install -d -m0755 %{buildroot}%{_sysconfdir}/dbus-1/system.d/
install -d -m0755 %{buildroot}%{_unitdir}/
install -d -m0755 %{buildroot}%{_userunitdir}/gamescope-session-plus.service.wants/
install -d -m0755 %{buildroot}%{_libdir}/

# Install binaries
install -D -m755 target/release/steamos-manager %{buildroot}%{_libdir}/steamos-manager
install -D -m755 target/release/steamosctl %{buildroot}%{_bindir}/steamosctl

# Install license
install -D -m644 LICENSE %{buildroot}%{_datadir}/licenses/%{name}/LICENSE

# Install systemd and dbus service files
install -m644 data/system/com.steampowered.SteamOSManager1.service %{buildroot}%{_datadir}/dbus-1/system-services/
install -m644 data/system/com.steampowered.SteamOSManager1.conf %{buildroot}%{_sysconfdir}/dbus-1/system.d/
install -m644 data/system/steamos-manager.service %{buildroot}%{_unitdir}/

# Install user-specific systemd and dbus service files
install -m644 data/user/com.steampowered.SteamOSManager1.service %{buildroot}%{_datadir}/dbus-1/services/
install -m644 data/user/steamos-manager.service %{buildroot}%{_userunitdir}/

# Create a symlink for the systemd service
ln -s ../steamos-manager.service %{buildroot}%{_userunitdir}/gamescope-session-plus.service.wants/steamos-manager.service

# we don't want this here
rm %{buildroot}%{_bindir}/steamos-manager

# Do post-installation
%post
%systemd_post steamos-manager.service

# Do before uninstallation
%preun
%systemd_preun steamos-manager.service

# Do after uninstallation
%postun
%systemd_postun_with_restart steamos-manager.service

%files
%license %{_datadir}/licenses/%{name}/LICENSE
%license LICENSE.dependencies
%license cargo-vendor.txt
%doc README.md

# Binaries
%{_bindir}/steamosctl
%{_libdir}/steamos-manager

# DBus Service Files
%{_datadir}/dbus-1/services/com.steampowered.SteamOSManager1.service
%{_datadir}/dbus-1/system-services/com.steampowered.SteamOSManager1.service

# DBus Configuration Files
%{_sysconfdir}/dbus-1/system.d/com.steampowered.SteamOSManager1.conf

# Systemd Service Files
%{_unitdir}/steamos-manager.service
%{_userunitdir}/steamos-manager.service

# Symlink for gamescope-session
%{_userunitdir}/gamescope-session-plus.service.wants/steamos-manager.service

%changelog
%autochangelog
